package com.persagy.apm.energyalarmstarter.alarmdata.aspect;

import com.persagy.apm.energyalarmstarter.alarmdata.feign.DmpResult;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;

/**
 * AlarmClient切面，处理feign调用接口，接口返回值异常的情况
 *
 * @author lixing
 * @version V1.0 2021/9/15 8:18 下午
 */
@Slf4j
@Aspect
@Component
public class AlarmClientAspect {
    @Pointcut("execution(public * com.persagy.apm.energyalarmstarter.alarmdata.feign.client.*.*(..))")
    public void feignPointCut() {
    }

    @Before("feignPointCut()")
    public void before() {
    }

    @AfterReturning(returning = "res", pointcut = "feignPointCut()")
    public void after(DmpResult res) {
        if (DmpResult.FAILURE.equals(res.getResult())) {
            throw new RuntimeException(res.getMessage());
        }
    }
}
