package com.persagy.apm.energyalarmstarter.alarmdata.utils;

import com.persagy.apm.energyalarmstarter.alarmdata.feign.DmpResult;
import org.springframework.boot.configurationprocessor.json.JSONObject;

/**
 * 数据中台返回结果处理类
 *
 * @author lixing
 * @version V1.0 2021/9/15 11:29 下午
 **/
public class DmpResultUtil {
    /**
     * 单个对象转换
     *
     * @param result 原始结果
     * @param clazz 需要转换的对象类
     * @return DmpResult(转换后的对象)
     * @author lixing
     * @version V1.0 2021/9/15 11:46 下午
     */
    public static <T> DmpResult<T> singleConvert(DmpResult<JSONObject> result, Class<T> clazz) throws Exception {
        if (result == null) {
            return null;
        }
        JSONObject data = result.getData();
        T reverse = Obj2JSONObject.reverse(data, clazz);

        DmpResult<T> tmp = copyBasicInfo(result);
        tmp.setData(reverse);
        return tmp;
    }

//    public static void main(String[] args) throws Exception {
//        DmpResult<JSONObject> result = new DmpResult<>();
//        result.setResult("result");
//        result.setMessage("message");
//        result.setCount(12);
//        JSONObject data = new JSONObject();
//        data.put("id", "12");
//        result.setData(data);
//        DmpResult<DmpUpsertVO> tDmpResult = singleConvert(result, DmpUpsertVO.class);
//        System.out.println(tDmpResult);
//    }

    private static <T> DmpResult<T> copyBasicInfo(DmpResult<JSONObject> result) {
        DmpResult<T> tmp = new DmpResult<>();
        tmp.setResult(result.getResult());
        tmp.setCount(result.getCount());
        tmp.setMessage(result.getMessage());
        return tmp;
    }

}
